<?xml version="1.0"?>

<!-- Copyright (C) 2000, HELM Team                                     -->
<!--                                                                   -->
<!-- This file is part of HELM, an Hypertextual, Electronic            -->
<!-- Library of Mathematics, developed at the Computer Science         -->
<!-- Department, University of Bologna, Italy.                         -->
<!--                                                                   -->
<!-- HELM is free software; you can redistribute it and/or             -->
<!-- modify it under the terms of the GNU General Public License       -->
<!-- as published by the Free Software Foundation; either version 2    -->
<!-- of the License, or (at your option) any later version.            -->
<!--                                                                   -->
<!-- HELM is distributed in the hope that it will be useful,           -->
<!-- but WITHOUT ANY WARRANTY; without even the implied warranty of    -->
<!-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the     -->
<!-- GNU General Public License for more details.                      -->
<!--                                                                   -->
<!-- You should have received a copy of the GNU General Public License -->
<!-- along with HELM; if not, write to the Free Software               -->
<!-- Foundation, Inc., 59 Temple Place - Suite 330, Boston,            -->
<!-- MA  02111-1307, USA.                                              -->
<!--                                                                   -->
<!-- For details, see the HELM World-Wide-Web page,                    -->
<!-- http://cs.unibo.it/helm/.                                         -->

<!--***********************************************************************--> 
<!-- XSLT version 0.1 of annotated MathML content to MathML presentation:  -->
<!-- First draft: March 29 2000, Claudio Sacerdoti Coen, Irene Schena      -->
<!--***********************************************************************--> 

<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                              xmlns:m="http://www.w3.org/1998/Math/MathML"
                              xmlns:helm="http://www.cs.unibo.it/helm">

<xsl:import href="objcontent.xsl"/>

<xsl:key name="id" use="@id" match="LAMBDA|LETIN|PROD|CAST|REL|SORT|APPLY|VAR|META|CONST|MUTIND|MUTCONSTRUCT|MUTCASE|FIX|COFIX|Definition|Axiom|CurrentProof|InductiveDefinition|Variable"/>

<xsl:key name="annid" use="@of" match="Annotation"/>

<xsl:template match="Definition|Axiom|CurrentProof|InductiveDefinition|Variable">
    <xsl:choose>
    <xsl:when test="key('annid',@id)">
     <annotation helm:xref="{@id}">
      <xsl:apply-templates select="key('annid',@id)"/>
     </annotation>
    </xsl:when>
    <xsl:otherwise>
     <xsl:apply-templates select="." mode="noannot"/>
    </xsl:otherwise>
    </xsl:choose>
</xsl:template>

<xsl:template match="LAMBDA|LETIN|PROD|CAST|REL|SORT|APPLY|VAR|META|CONST|MUTIND|MUTCONSTRUCT|MUTCASE|FIX|COFIX">
    <xsl:choose>
    <xsl:when test="key('annid',@id)">
     <annotation helm:xref="{@id}">
      <xsl:apply-templates select="key('annid',@id)"/>
     </annotation>
    </xsl:when>
    <xsl:otherwise>
     <m:math>
      <xsl:apply-templates select="." mode="noannot"/>
     </m:math>
    </xsl:otherwise>
    </xsl:choose>
</xsl:template>

<xsl:template match="node">
 <xsl:variable name="id" select="@id"/>
 <xsl:apply-templates select="key('id',$id)"/>
</xsl:template>

<xsl:template match="attribute">
 <xsl:variable name="id" select="@id"/>
 <xsl:variable name="name" select="@name"/>
 <xsl:variable name="child" select="@child"/>
 <xsl:variable name="grandchild" select="@grandchild"/>
 <xsl:choose>
  <xsl:when test="$child">
   <xsl:choose>
    <xsl:when test="$grandchild">
     <xsl:value-of select="key('id',$id)/*[position() = $child]/*[position() = $grandchild]/attribute::*[name() = $name]"/>
    </xsl:when>
    <xsl:otherwise>
     <xsl:value-of select="key('id',$id)/*[position() = $child]/attribute::*[name() = $name]"/>
    </xsl:otherwise>
   </xsl:choose>
  </xsl:when>
  <xsl:otherwise>
   <xsl:value-of select="key('id',$id)/attribute::*[name() = $name]"/>
  </xsl:otherwise>
 </xsl:choose>
</xsl:template>

</xsl:stylesheet>
