<?xml version="1.0"?>

<!-- Copyright (C) 2000, HELM Team                                     -->
<!--                                                                   -->
<!-- This file is part of HELM, an Hypertextual, Electronic            -->
<!-- Library of Mathematics, developed at the Computer Science         -->
<!-- Department, University of Bologna, Italy.                         -->
<!--                                                                   -->
<!-- HELM is free software; you can redistribute it and/or             -->
<!-- modify it under the terms of the GNU General Public License       -->
<!-- as published by the Free Software Foundation; either version 2    -->
<!-- of the License, or (at your option) any later version.            -->
<!--                                                                   -->
<!-- HELM is distributed in the hope that it will be useful,           -->
<!-- but WITHOUT ANY WARRANTY; without even the implied warranty of    -->
<!-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the     -->
<!-- GNU General Public License for more details.                      -->
<!--                                                                   -->
<!-- You should have received a copy of the GNU General Public License -->
<!-- along with HELM; if not, write to the Free Software               -->
<!-- Foundation, Inc., 59 Temple Place - Suite 330, Boston,            -->
<!-- MA  02111-1307, USA.                                              -->
<!--                                                                   -->
<!-- For details, see the HELM World-Wide-Web page,                    -->
<!-- http://cs.unibo.it/helm/.                                         -->

<!--******************************************************************--> 
<!-- Reals                                                            -->
<!-- First draft: April 3 2000                                        -->
<!-- HELM Group: Asperti, Padovani, Sacerdoti, Schena                 -->
<!--******************************************************************-->

<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                              xmlns:m="http://www.w3.org/1998/Math/MathML"
                              xmlns:helm="http://www.cs.unibo.it/helm"
                              xmlns:xlink="http://www.w3.org/1999/xlink">

<!--******************************************************************-->
<!-- Variable containing the absolute path of the CIC file            -->
<!--******************************************************************-->

<xsl:variable name="absPath">http://localhost:8081/getciconly?uri=</xsl:variable>

<!-- ************************* LOGIC *********************************-->

<!-- REALS -->

<!--
<xsl:template match="CONST[attribute::uri='cic:/Coq/Reals/Rdefinitions/R.con']" mode="pure">
 <m:reals/>
</xsl:template>
-->

<!-- 0 e 1 -->

<xsl:template match="CONST[attribute::uri='cic:/Coq/Reals/Rdefinitions/R0.con']" mode="pure">
 <m:cn definitionURL="{@uri}" helm:xref="{@id}">0</m:cn>
</xsl:template>

<xsl:template match="CONST[attribute::uri='cic:/Coq/Reals/Rdefinitions/R1.con']" mode="pure">
 <m:cn definitionURL="{@uri}" helm:xref="{@id}">1</m:cn>
</xsl:template>



<!-- Unary Operations and power -->

<xsl:template match="APPLY[CONST[
 attribute::uri='cic:/Coq/Reals/Rdefinitions/Ropp.con' or
 attribute::uri='cic:/Coq/Reals/Rbasic_fun/Rabsolu.con' or
 attribute::uri='cic:/Coq/Reals/Rfunctions/fact.con' or
 attribute::uri='cic:/Coq/Reals/Rbase/Rsqr.con']]" mode="pure">
    <xsl:choose>
     <xsl:when test="count(child::*) = 2">
      <xsl:variable name="elem">
       <xsl:choose>
        <xsl:when test="CONST/@uri='cic:/Coq/Reals/Rdefinitions/Ropp.con'">
         <xsl:value-of select="'minus'"/>
        </xsl:when>
        <xsl:when test="CONST/@uri='cic:/Coq/Reals/Rbasic_fun/Rabsolu.con'">
         <xsl:value-of select="'abs'"/>
        </xsl:when>
        <xsl:when test="CONST/@uri='cic:/Coq/Reals/Rfunctions/fact.con'">
         <xsl:value-of select="'factorial'"/>
        </xsl:when>
        <xsl:when test="CONST/@uri='cic:/Coq/Reals/Rbase/Rsqr.con'">
         <xsl:value-of select="'power'"/>
        </xsl:when>
       </xsl:choose>
      </xsl:variable>
      <m:apply helm:xref="{@id}">
       <xsl:element name="{concat('m:',$elem)}">
        <xsl:attribute name="definitionURL">
         <xsl:value-of select="CONST/@uri"/> 
        </xsl:attribute>
        <xsl:attribute name="helm:xref">
         <xsl:value-of select="CONST/@id"/>
        </xsl:attribute>
       </xsl:element>
       <xsl:apply-templates select="*[2]" mode="noannot"/>
       <xsl:if test="string($elem)='power'">
        <m:cn><xsl:value-of select="*[2]/@value"/></m:cn>
       </xsl:if>
      </m:apply>
     </xsl:when>
     <xsl:otherwise>
      <xsl:apply-imports/>
     </xsl:otherwise>
    </xsl:choose>
</xsl:template>

<xsl:template match="APPLY[CONST[
 attribute::uri='cic:/Coq/Reals/Rdefinitions/Rinv.con']]" mode="pure">
    <xsl:choose>
     <xsl:when test="count(child::*) = 2">
      <m:apply helm:xref="{@id}">
       <m:power/>
       <xsl:apply-templates select="*[2]" mode="noannot"/>
       <m:apply>
        <m:minus>
         <xsl:attribute name="definitionURL">
          <xsl:value-of select="CONST/@uri"/> 
         </xsl:attribute>
         <xsl:attribute name="helm:xref">
          <xsl:value-of select="CONST/@id"/>
         </xsl:attribute>
        </m:minus>
        <m:cn>1</m:cn>
       </m:apply>
      </m:apply>
     </xsl:when>
     <xsl:otherwise>
      <xsl:apply-imports/>
     </xsl:otherwise>
    </xsl:choose>
</xsl:template>

<!-- Binary Operations and Relations -->

<xsl:template match="APPLY[CONST[
 attribute::uri='cic:/Coq/Reals/Rdefinitions/Rplus.con' or
 attribute::uri='cic:/Coq/Reals/Rdefinitions/Rminus.con' or
 attribute::uri='cic:/Coq/Reals/Rdefinitions/Rmult.con' or
 attribute::uri='cic:/Coq/Reals/Rdefinitions/Rle.con' or
 attribute::uri='cic:/Coq/Reals/Rdefinitions/Rlt.con' or
 attribute::uri='cic:/Coq/Reals/Rdefinitions/Rge.con' or
 attribute::uri='cic:/Coq/Reals/Rdefinitions/Rgt.con' or
 attribute::uri='cic:/Coq/Reals/Rbasic_fun/Rmin.con' or
 attribute::uri='cic:/Coq/Reals/Rfunctions/pow.con']]" mode="pure">
    <xsl:choose>
     <xsl:when test="count(child::*) = 3">
      <xsl:variable name="elem">
       <xsl:choose>
        <xsl:when test="CONST/@uri='cic:/Coq/Reals/Rdefinitions/Rplus.con'">
         <xsl:value-of select="'plus'"/>
        </xsl:when>
        <xsl:when test="CONST/@uri='cic:/Coq/Reals/Rdefinitions/Rminus.con'">
         <xsl:value-of select="'minus'"/>
        </xsl:when>
        <xsl:when test="CONST/@uri='cic:/Coq/Reals/Rdefinitions/Rmult.con'">
         <xsl:value-of select="'times'"/>
        </xsl:when>
        <xsl:when test="CONST/@uri='cic:/Coq/Reals/Rdefinitions/Rle.con'">
         <xsl:value-of select="'leq'"/>
        </xsl:when>
        <xsl:when test="CONST/@uri='cic:/Coq/Reals/Rdefinitions/Rlt.con'">
         <xsl:value-of select="'lt'"/>
        </xsl:when>
        <xsl:when test="CONST/@uri='cic:/Coq/Reals/Rdefinitions/Rge.con'">
         <xsl:value-of select="'geq'"/>
        </xsl:when>
        <xsl:when test="CONST/@uri='cic:/Coq/Reals/Rdefinitions/Rgt.con'">
         <xsl:value-of select="'gt'"/>
        </xsl:when>
        <xsl:when test="CONST/@uri='cic:/Coq/Reals/Rbasic_fun/Rmin.con'">
         <xsl:value-of select="'min'"/>
        </xsl:when>
        <xsl:when test="CONST/@uri='cic:/Coq/Reals/Rfunctions/pow.con'">
         <xsl:value-of select="'power'"/>
        </xsl:when>
       </xsl:choose>
      </xsl:variable>
      <m:apply helm:xref="{@id}">
       <xsl:element name="{concat('m:',$elem)}">
        <xsl:attribute name="definitionURL">
         <xsl:value-of select="CONST/@uri"/> 
        </xsl:attribute>
        <xsl:attribute name="helm:xref">
         <xsl:value-of select="CONST/@id"/>
        </xsl:attribute>
       </xsl:element>
       <xsl:apply-templates select="*[2]" mode="noannot"/>
       <xsl:apply-templates select="*[3]" mode="noannot"/>
      </m:apply>
     </xsl:when>
     <xsl:otherwise>
      <xsl:apply-imports/>
     </xsl:otherwise>
    </xsl:choose>
</xsl:template>

<!-- LIMIT -->

<xsl:template match="APPLY[CONST[
 attribute::uri='cic:/Coq/Reals/Rlimit/limit1_in.con']]" mode="pure">
    <xsl:choose>
     <xsl:when test="count(child::*) = 5">
      <m:apply>
       <m:eq/>
       <xsl:choose>
        <xsl:when test="name(*[2]) = 'LAMBDA'">
         <m:apply helm:xref="{@id}">
          <m:limit>
           <xsl:attribute name="definitionURL">
            <xsl:value-of select="CONST/@uri"/> 
           </xsl:attribute>
           <xsl:attribute name="helm:xref">
            <xsl:value-of select="CONST/@id"/>
           </xsl:attribute>
          </m:limit>
          <m:bvar>
           <m:ci>
            <xsl:call-template name="insert_subscript"><xsl:with-param name="node_value"><xsl:value-of select="LAMBDA/target/@binder"/></xsl:with-param></xsl:call-template>
           </m:ci>
          </m:bvar>
          <m:lowlimit>
           <xsl:apply-templates select="*[5]" mode="noannot"/>
          </m:lowlimit>
          <xsl:apply-templates select="*[2]/target" mode="noannot"/>
         </m:apply>
        </xsl:when>
        <xsl:otherwise>
         <m:apply helm:xref="{@id}">
          <m:limit>
            <xsl:attribute name="definitionURL">
             <xsl:value-of select="CONST/@uri"/> 
            </xsl:attribute>
            <xsl:attribute name="helm:xref">
             <xsl:value-of select="CONST/@id"/>
            </xsl:attribute>
           </m:limit>
          <m:bvar>
           <m:ci>$x</m:ci>
          </m:bvar>
          <m:lowlimit>
           <xsl:apply-templates select="*[5]" mode="noannot"/>
          </m:lowlimit>
          <m:apply>
           <m:csymbol>app</m:csymbol>
           <xsl:apply-templates select="*[2]" mode="noannot"/>
           <m:ci>$x</m:ci>
          </m:apply>
         </m:apply>
        </xsl:otherwise>
       </xsl:choose>
       <xsl:apply-templates select="*[4]" mode="noannot"/>
      </m:apply>
     </xsl:when>
     <xsl:otherwise>
      <xsl:apply-imports/>
     </xsl:otherwise>
    </xsl:choose>
</xsl:template>

<!-- DIFFERENTIATION -->

<xsl:template match="APPLY[CONST[
 attribute::uri='cic:/Coq/Reals/Rderiv/D_in.con']]" mode="pure">
    <xsl:choose>
     <xsl:when test="count(child::*) = 4">
      <m:apply>
       <m:eq/>
       <xsl:choose>
        <xsl:when test="name(*[2]) = 'LAMBDA'">
         <m:apply helm:xref="{@id}">
          <m:diff>
           <xsl:attribute name="definitionURL">
            <xsl:value-of select="CONST/@uri"/> 
           </xsl:attribute>
           <xsl:attribute name="helm:xref">
            <xsl:value-of select="CONST/@id"/>
           </xsl:attribute>
          </m:diff>
          <m:bvar>
           <m:ci><xsl:call-template name="insert_subscript"><xsl:with-param name="node_value"><xsl:value-of select="LAMBDA[1]/target/@binder"/></xsl:with-param></xsl:call-template></m:ci>
          </m:bvar>
          <xsl:apply-templates select="*[2]/target" mode="noannot"/>
         </m:apply>
        </xsl:when>
        <xsl:otherwise>
         <m:apply helm:xref="{@id}">
          <m:diff/>
          <m:bvar>
           <m:ci>$x</m:ci>
          </m:bvar>
          <m:apply>
           <m:csymbol>app</m:csymbol>
           <xsl:apply-templates select="*[2]" mode="noannot"/>
           <m:ci>$x</m:ci>
          </m:apply>
         </m:apply>
        </xsl:otherwise>
       </xsl:choose>
       <xsl:apply-templates select="*[4]" mode="noannot"/>
      </m:apply>
     </xsl:when>
     <xsl:otherwise>
      <xsl:apply-imports/>
     </xsl:otherwise>
    </xsl:choose>
</xsl:template>

</xsl:stylesheet>


