<?xml version="1.0"?>

<!-- Copyright (C) 2000, HELM Team                                     -->
<!--                                                                   -->
<!-- This file is part of HELM, an Hypertextual, Electronic            -->
<!-- Library of Mathematics, developed at the Computer Science         -->
<!-- Department, University of Bologna, Italy.                         -->
<!--                                                                   -->
<!-- HELM is free software; you can redistribute it and/or             -->
<!-- modify it under the terms of the GNU General Public License       -->
<!-- as published by the Free Software Foundation; either version 2    -->
<!-- of the License, or (at your option) any later version.            -->
<!--                                                                   -->
<!-- HELM is distributed in the hope that it will be useful,           -->
<!-- but WITHOUT ANY WARRANTY; without even the implied warranty of    -->
<!-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the     -->
<!-- GNU General Public License for more details.                      -->
<!--                                                                   -->
<!-- You should have received a copy of the GNU General Public License -->
<!-- along with HELM; if not, write to the Free Software               -->
<!-- Foundation, Inc., 59 Temple Place - Suite 330, Boston,            -->
<!-- MA  02111-1307, USA.                                              -->
<!--                                                                   -->
<!-- For details, see the HELM World-Wide-Web page,                    -->
<!-- http://cs.unibo.it/helm/.                                         -->

<xsl:stylesheet version="0.1" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

<xsl:output method="html"/>


<!--******************************************************************-->
<!-- Variable containing the absolute path of the CIC file            -->
<!--******************************************************************-->

<xsl:variable name="absPath">http://localhost:8081/getciconly?uri=</xsl:variable>

<xsl:template match="/">
               <html> 
                <head></head>
                <body>
                <xsl:apply-templates select="Theory"/>
                </body>
               </html>
</xsl:template>


<!-- CIC TERMS -->



<xsl:template match="MUTIND[string(@uri)='cic:/Coq/Init/Logic/Equality/eq.ind']" mode="search" >
<!-- <xsl:param name="current_uri" select=""/> -->
<!-- <h1><xsl:value-of select="string(@uri)"/></h1> -->
<!-- <xsl:if test="string(@uri)='cic:/Coq/Init/Logic/Equality/eq.ind'"> -->
  <xsl:value-of select="$current_uri"/><BR/>
<!-- </xsl:if> -->
</xsl:template>

<!-- AGGIUNGERE cic: alle uri nei file Theory -->

<xsl:template match="Theory">
<!-- <xsl:param name="current_uri" select=""/> -->
 <xsl:apply-templates>
  <xsl:with-param name="current_uri" select="string(@uri)"/>
 </xsl:apply-templates>
</xsl:template>

<xsl:template match="VARIABLE">
<!-- <xsl:param name="current_uri" select=""/> -->
<xsl:variable name="found" 
  select="boolean(document(concat(string($absPath),string($current_uri),&quot;/&quot;,string(@uri)))//MUTIND[string(@uri)='cic:/Coq/Init/Logic/Equality/eq.ind'])"/>
<xsl:if test="$found">
  <xsl:value-of select="concat(string($current_uri),&quot;/&quot;,string(@uri),&quot;.xml&quot;)"/><BR/>
</xsl:if>

<!--   <xsl:with-param name="current_uri" select="concat(string($absPath),string($current_uri),&quot;/&quot;,string(@uri))"/>
 </xsl:apply-templates> -->
</xsl:template>

<xsl:template match="DEFINITION">
<!-- <xsl:param name="current_uri" select=""/> -->
<!-- <xsl:apply-templates select="document(concat(string($absPath),string($current_uri),&quot;/&quot;,string(@uri)))" mode="search">
  <xsl:with-param name="current_uri" select="concat(string($absPath),string($current_uri),&quot;/&quot;,string(@uri))"/>
 </xsl:apply-templates> -->
<xsl:variable name="found" 
  select="boolean(document(concat(string($absPath),string($current_uri),&quot;/&quot;,string(@uri)))//MUTIND[string(@uri)='cic:/Coq/Init/Logic/Equality/eq.ind'])"/>
<xsl:if test="$found">
  <xsl:value-of select="concat(string($current_uri),&quot;/&quot;,string(@uri),&quot;.xml&quot;)"/><BR/>
</xsl:if>
</xsl:template>

<xsl:template match="THEOREM">
<!-- <xsl:param name="current_uri" select=""/> -->
<!-- <xsl:apply-templates select="document(concat(string($absPath),string($current_uri),&quot;/&quot;,string(@uri)))" mode="search">
  <xsl:with-param name="current_uri" select="concat(string($absPath),string($current_uri),&quot;/&quot;,string(@uri))"/>
 </xsl:apply-templates> -->
<xsl:variable name="found" 
  select="boolean(document(concat(string($absPath),string($current_uri),&quot;/&quot;,string(@uri)))//MUTIND[string(@uri)='cic:/Coq/Init/Logic/Equality/eq.ind'])"/>
<xsl:if test="$found">
  <xsl:value-of select="concat(string($current_uri),&quot;/&quot;,string(@uri),&quot;.xml&quot;)"/><BR/>
</xsl:if>
</xsl:template>


<xsl:template match="SECTION">
<!-- <xsl:param name="current_uri" select=""/> -->
 <xsl:apply-templates>
  <xsl:with-param name="current_uri" select="concat($current_uri,&quot;/&quot;,string(@uri))"/>
 </xsl:apply-templates>

</xsl:template>

</xsl:stylesheet>
