<?xml version="1.0"?>

<!-- Copyright (C) 2000, HELM Team                                     -->
<!--                                                                   -->
<!-- This file is part of HELM, an Hypertextual, Electronic            -->
<!-- Library of Mathematics, developed at the Computer Science         -->
<!-- Department, University of Bologna, Italy.                         -->
<!--                                                                   -->
<!-- HELM is free software; you can redistribute it and/or             -->
<!-- modify it under the terms of the GNU General Public License       -->
<!-- as published by the Free Software Foundation; either version 2    -->
<!-- of the License, or (at your option) any later version.            -->
<!--                                                                   -->
<!-- HELM is distributed in the hope that it will be useful,           -->
<!-- but WITHOUT ANY WARRANTY; without even the implied warranty of    -->
<!-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the     -->
<!-- GNU General Public License for more details.                      -->
<!--                                                                   -->
<!-- You should have received a copy of the GNU General Public License -->
<!-- along with HELM; if not, write to the Free Software               -->
<!-- Foundation, Inc., 59 Temple Place - Suite 330, Boston,            -->
<!-- MA  02111-1307, USA.                                              -->
<!--                                                                   -->
<!-- For details, see the HELM World-Wide-Web page,                    -->
<!-- http://cs.unibo.it/helm/.                                         -->

<!--***********************************************************************--> 
<!-- XSLT version 0.1 of the stylesheet to accomplish the right inclusion  -->
<!-- of the content stylesheets:                                           -->
<!-- First draft: May 26 2000, Claudio Sacerdoti Coen, Irene Schena        -->
<!--***********************************************************************-->

<!-- Schema of stylesheet precedences (from highest to lowest):          -->
<!-- proofs.xsl-> reals.xsl-> set -> basic -> annotatedcont              -->
<!-- because annotatedcont is imported and has lower precendence than    -->
<!-- the templates of rootcontent (i.e. the templates of set and basic). -->
<!-- annotatedcont -> objcontent -> content                              -->
<!-- because annotatedcont generates an import precedence tree.          --> 

<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">


<xsl:import href="annotatedcont.xsl"/>
<xsl:key name="id" use="@id" match="LAMBDA|LETIN|PROD|CAST|REL|SORT|APPLY|VAR|META|CONST|MUTIND|MUTCONSTRUCT|MUTCASE|FIX|COFIX|Definition|Axiom|CurrentProof|InductiveDefinition|Variable"/>
<xsl:include href="basic.xsl"/>
<xsl:include href="set.xsl"/>
<xsl:include href="reals.xsl"/>
<xsl:include href="proofs.xsl"/>

<xsl:variable name="showproof" select="0"/>
</xsl:stylesheet>



