<?xml version="1.0"?>

<!-- Copyright (C) 2000, HELM Team                                     -->
<!--                                                                   -->
<!-- This file is part of HELM, an Hypertextual, Electronic            -->
<!-- Library of Mathematics, developed at the Computer Science         -->
<!-- Department, University of Bologna, Italy.                         -->
<!--                                                                   -->
<!-- HELM is free software; you can redistribute it and/or             -->
<!-- modify it under the terms of the GNU General Public License       -->
<!-- as published by the Free Software Foundation; either version 2    -->
<!-- of the License, or (at your option) any later version.            -->
<!--                                                                   -->
<!-- HELM is distributed in the hope that it will be useful,           -->
<!-- but WITHOUT ANY WARRANTY; without even the implied warranty of    -->
<!-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the     -->
<!-- GNU General Public License for more details.                      -->
<!--                                                                   -->
<!-- You should have received a copy of the GNU General Public License -->
<!-- along with HELM; if not, write to the Free Software               -->
<!-- Foundation, Inc., 59 Temple Place - Suite 330, Boston,            -->
<!-- MA  02111-1307, USA.                                              -->
<!--                                                                   -->
<!-- For details, see the HELM World-Wide-Web page,                    -->
<!-- http://cs.unibo.it/helm/.                                         -->

<!--***********************************************************************--> 
<!-- XSLT version 0.1 of theory objects to theory sections:                -->
<!-- First draft: May 08 2000, Claudio Sacerdoti Coen, Irene Schena        -->
<!--***********************************************************************--> 

<xsl:stylesheet version="0.1" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

<xsl:import href="rootcontent.xsl"/>

<!--******************************************************************-->
<!-- Variable containing the absolute path of the CIC file            -->
<!--******************************************************************-->

<xsl:variable name="absPath">http://localhost:8081/getciconly?uri=</xsl:variable>

<!-- THEORY -->

<xsl:template match="Theory">
    <SECTION>
     <xsl:apply-templates><xsl:with-param name="current_uri" select="string(@uri)"/></xsl:apply-templates>
    </SECTION>
</xsl:template>

<!-- SUBTHEORY -->

<xsl:template match="SECTION">
<xsl:param name="current_uri"/>
    <SECTION>
     <xsl:apply-templates><xsl:with-param name="current_uri" select="concat($current_uri,&quot;/&quot;,string(@uri))"/></xsl:apply-templates>
    </SECTION>
</xsl:template>

<!-- THEORY ELEMENTS -->

<xsl:template match="DEFINITION">
<xsl:param name="current_uri"/>
    <xsl:apply-templates select="document(concat(string($absPath),string($current_uri),&quot;/&quot;,string(@uri)))"/>
</xsl:template>

<xsl:template match="AXIOM">
<xsl:param name="current_uri"/>
    <xsl:apply-templates select="document(concat(string($absPath),string($current_uri),&quot;/&quot;,string(@uri)))"/>
</xsl:template>

<xsl:template match="THEOREM">
<xsl:param name="current_uri"/>
    <xsl:apply-templates select="document(concat(string($absPath),string($current_uri),&quot;/&quot;,string(@uri)))"/>
</xsl:template>

<xsl:template match="VARIABLE">
<xsl:param name="current_uri"/>
    <xsl:apply-templates select="document(concat(string($absPath),string($current_uri),&quot;/&quot;,string(@uri)))"/>
</xsl:template>

</xsl:stylesheet>
